Subject: Re: [PATCH] ehea: Fix a checksum issue on the receive path

From: Stephen Hemminger <[email-masked]>
Date: Sat, 9 Oct 2010 10:31:36 -0700

On Sat, 09 Oct 2010 09:20:43 -0700 (PDT)
David Miller <[email-masked]> wrote:

> From: Eric Dumazet <[email-masked]>
> Date: Fri, 08 Oct 2010 16:36:17 +0200
> 
> > I am pretty sure most (if not all) netdev drivers pass the packet with
> > invalid checksum to upper stack, so that we can increment appropriate
> > SNMP counters, in IP stack or UDP/TCP/whatever stack.
> > 
> > tg3, bnx2, e1000, skge, sky2, bnx2x, niu, r8169, igb, ... seems to do
> > that.
> 
> Drivers _must_ send up all packets, even those with bad checksums,
> without exception.
> 
> Otherwise protocol statistics get lost, netfilter log entries go
> missing, etc.

Also hardware checksum can be wrong/broken. By passing up a packet
which the driver thinks is bad, the software can still work.